host info updates
[distro-setup] / switch-mail-host
index 577d50058570dce5f98219f48a8f37a3a8bf598c..053134aac9ace8b5981e551c2653851899c6c29e 100644 (file)
@@ -1,6 +1,27 @@
 #!/bin/bash
+# I, Ian Kelling, follow the GNU license recommendations at
+# https://www.gnu.org/licenses/license-recommendations.en.html. They
+# recommend that small programs, < 300 lines, be licensed under the
+# Apache License 2.0. This file contains or is part of one or more small
+# programs. If a small program grows beyond 300 lines, I plan to switch
+# its license to GPL.
 
-source /usr/local/lib/err
+# Copyright 2024 Ian Kelling
+
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+
+#     http://www.apache.org/licenses/LICENSE-2.0
+
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+
+set -e; . /usr/local/lib/bash-bear; set +e
 
 usage() {
   cat <<EOF
@@ -26,7 +47,7 @@ on the internet. Email can wait.
 
 Note: Uses GNU getopt options parsing style
 EOF
-  exit $1
+  exit 0
 }
 
 script_name="${BASH_SOURCE[0]}"
@@ -45,10 +66,11 @@ err-cleanup() {
   fi
 }
 
-pre="${SSH_CLIENT:+$HOSTNAME} $script_name:"
+pre="$script_name:"
 m() { printf "$pre %s\n"  "$*"; "$@"; }
 e() { printf "$pre %s\n"  "$*"; }
 err() { echo "$pre ERROR: $*" >&2; }
+die() { printf "%s\n" "$*" >&2; echo "exiting with status 1" >&2; exit 1; }
 
 if [[ $EUID != 0 ]]; then
   err "requires running as root"
@@ -61,14 +83,28 @@ fi
 mail_only=false
 host2_only=false
 force=false
-mp_args="-m /o,/a,/ar,/q,/qr"
-temp=$(getopt -l force,help aioh "$@") || usage 1
+force_arg=
+pull_reexec=false
+mp_args="-m /o,/a,/q,/qd,/qr"
+check_installed=false
+orig_args=("$@")
+if ! temp=$(getopt -l check-installed,force,pull-reexec,help afioh "$@"); then
+  err "args invalid. args=$*"
+fi
 eval set -- "$temp"
 while true; do
   case $1 in
     -a) snapshot_arg=resume ;;
-    --force) force=true ;;
+    --force|-f)
+      force=true
+      force_arg=-f
+      ;;
+    --check-installed)
+      check_installed=true
+      ;;
     -i) incremental_arg="-i" ;;
+    # internal option for rerunning under newer old_host when doing pull
+    --pull-reexec) pull_reexec=true;;
     -o)
       mail_only=true ;;
     -h|--help) usage ;;
@@ -79,17 +115,67 @@ while true; do
 done
 
 
-(( $# == 2 )) || usage 1
+if (( $# != 2 )) && ! $check_installed; then
+  err expected 2 args, got $#
+fi
 
 if [[ ! $HOSTNAME ]]; then
   err "\$HOSTNAME is unset"
   exit 1
 fi
 
+uninstalled-file-die() {
+  die "on host=$HOSTNAME, uninstalled file $1. run install-my-scripts or rerun with -f"
+}
+
+
 source /a/bin/bash_unpublished/source-state
 
 direction=$1
 host=$2
+
+case $script_name in
+  switch-mail-host)
+    if [[ $MAIL_HOST != "$HOST2" ]]; then
+      mail_only=true
+    fi
+    ;;
+  switch-host2)
+    host2_only=true
+    ;;
+  *)
+    err unexpected script name
+    ;;
+esac
+
+if $mail_only; then
+  mp_args="-m /o"
+elif $host2_only; then
+  mp_args="-m /a,/q,/qd,/qr"
+fi
+
+
+if ! $force && { $check_installed || [[ $direction == push ]]; } ; then
+  install_bin_files=(
+    mount-latest-subvol
+    check-subvol-stale
+    btrbk-run
+    switch-mail-host
+  )
+  for f in ${install_bin_files[@]}; do
+    if ! diff -q /a/bin/ds/$f /usr/local/bin/$f; then
+      uninstalled-file-die $f
+    fi
+  done
+  if ! diff -q /a/bin/bash-bear-trap/bash-bear /usr/local/lib/bash-bear; then
+    uninstalled-file-die err
+  fi
+  if $check_installed; then
+    exit 0
+  fi
+fi
+
+
 case $direction in
   push)
     old_host=$HOSTNAME
@@ -108,17 +194,43 @@ case $direction in
     new_hostname=$HOSTNAME
     bbk_args="-s $old_host"
     old_shell="ssh -F $HOME/.ssh/confighome root@$old_host"
-    old_shelliank="ssh -F $HOME/.ssh/confighome iank@$old_host"
     # tests ssh connection. crafted this to not need to do escape chars
+
+    if ! $mail_only && ! $pull_reexec ; then
+      if ! $force; then
+        if ! $old_shell switch-mail-host --check-installed; then
+          die "failed: $old_shell switch-mail-host --check-installed"
+        fi
+      fi
+      tmpd=$(mktemp -d)
+      files=(
+        /usr/local/{bin/{unsaved-buffers{,.el},switch-mail-host},lib/bash-bear}
+      )
+      m scp -F $HOME/.ssh/confighome \
+        ${files[@]/#/root@$old_host:} $tmpd
+      diff=false
+      for f in ${files[@]}; do
+        if ! diff -q $tmpd/${f##*/} $f; then
+          m install -T $tmpd/${f##*/} $f
+          diff=true
+        fi
+      done
+      if $diff; then
+        e "found different version on old_host=$old_host, reexecing"
+        m /usr/local/bin/switch-mail-host --pull-reexec "${orig_args[@]}"
+        exit 0
+      fi
+      rm -r -- $tmpd
+    fi
+
     f=/a/bin/bash_unpublished/source-state
-    if ! old_info=($($old_shell "hostname; sed -n s,.*MAIL_HOST=,,p $f; sed -n s,.*HOST2=,,p $f")); then
+    if ! old_info=$($old_shell "hostname; sed -n s,.*MAIL_HOST=,,p $f; sed -n s,.*HOST2=,,p $f"); then
       echo "$pre: error: failed ssh. retrying failed $old_shell with -v for more info:"
       $old_shell -v hostname
       exit 1
     fi
-    old_hostname=${old_info[0]}
-    MAIL_HOST=${old_info[1]}
-    HOST2=${old_info[2]}
+    read -d '' -r old_hostname MAIL_HOST HOST2 <<<"$old_info" || (( $? == 1 ))
+
     ;;
   *)
     err invalid first argument
@@ -126,25 +238,6 @@ case $direction in
     ;;
 esac
 
-case $script_name in
-  switch-mail-host)
-    if [[ $MAIL_HOST != "$HOST2" ]]; then
-      mail_only=true
-    fi
-    ;;
-  switch-host2)
-    host2_only=true
-    ;;
-  *)
-    err unexpected script name
-    ;;
-esac
-
-if $mail_only; then
-  mp_args="-m /o"
-elif $host2_only; then
-  mp_args="-m /a,/ar,/q,/qr"
-fi
 
 if ! $force; then
   if $host2_only; then
@@ -196,21 +289,13 @@ while $active; do
   done
 done
 
-# ensure these are unused before doing anything
-e "On $new_host: umounting /m and /o, checking emacs"
-{
-  cat <<'EOF'
-set -eE
-if pgrep -G iank -u iank -f 'emacs --daemon' &>/dev/null; then
-  bufs="$(sudo -u iank env XDG_RUNTIME_DIR=/run/user/1000 emacsclient --eval "$(cat /a/bin/ds/unsaved-buffers.el)"| sed '/^"nil"$/d;s/^"(/E: /;s/)"$//')"
-  if [[ $bufs ]]; then
-    echo "error: on $HOSTNAME, unsaved emacs files: $bufs" >&2
-    exit 1
-  fi
-fi
-EOF
-  if ! $host2_only; then
-    cat <<EOF
+if ! $host2_only; then
+  # ensure these are unused before doing anything
+  e "On $new_host: umounting /m and /o, checking emacs"
+  {
+    cat /usr/local/bin/unsaved-buffers
+    if ! $host2_only; then
+      cat <<EOF
 for dir in m o; do
   if mountpoint -q /\$dir; then
     echo On $new_host: umount /\$dir
@@ -218,18 +303,22 @@ for dir in m o; do
   fi
 done
 EOF
-  fi
-} | $new_shell bash -s
+    fi
+  } | $new_shell bash -s
+fi
 
-$old_shell bash -s <<'EOF'
-if pgrep -G iank -u iank -f 'emacs --daemon' &>/dev/null; then
-  bufs="$(sudo -u iank env XDG_RUNTIME_DIR=/run/user/1000 emacsclient --eval "$(cat /a/bin/ds/unsaved-buffers.el)"| sed '/^"nil"$/d;s/^"(/E: /;s/)"$//')"
-  if [[ $bufs ]]; then
-    echo "error: on $HOSTNAME, unsaved emacs files: $bufs" >&2
-    exit 1
-  fi
+if ! $mail_only; then
+  cat /usr/local/bin/unsaved-buffers - <<'EOF' |  $old_shell bash -s
+
+# Try to prevent emacs from saving stale data it has in memory to disk. eg: files, recentf list, etc.
+# But if emacs ignores the signal, let it live.
+pkill -xf 'emacs( --daemon| -f znc-all)' ||:
+
+if [[ -e /p/profanity-here ]]; then
+  systemctl disable --now profanity
 fi
 EOF
+fi
 
 # previously, I was checking to see if the new mail host
 # is on my home network, then changing my home dns
@@ -247,7 +336,7 @@ EOF
 
 
 e Running initial btrbk
-m btrbk-run -v $bbk_args $incremental_arg $mp_args $snapshot_arg || ret=$?
+m btrbk-run -v $bbk_args $force_arg $incremental_arg $mp_args $snapshot_arg || ret=$?
 if (( ret )); then
   err "failed initial btrbk"
   exit $ret
@@ -263,6 +352,9 @@ if $host2_only; then
     m $old_shell systemctl --now disable btrbk.timer
   fi
   m $new_shell systemctl --now enable btrbk.timer
+  if [[ -e /p/profanity-here ]]; then
+    m $new_shell systemctl --now enable profanity
+  fi
   exit 0
 fi
 
@@ -272,22 +364,22 @@ if (( ret )); then
   exit $ret
 fi
 
-# Try to prevent emacs from saving stale data it has in memory to disk. eg: files, recentf list, etc.
-# But if emacs ignores the signal, let it live.
-m $new_shell killall -q emacs ||:
 
 e Running main btrbk
-m btrbk-run -v --fast $bbk_args $incremental_arg -m /o || ret=$?
+m btrbk-run -v --fast $bbk_args $force_arg $incremental_arg -m /o || ret=$?
 if (( ret )); then
-  bang="$(printf "$(tput setaf 5)█$(tput sgr0)%.0s" 1 2 3 4 5 6 7)"
+  bang="███████"
   e $bang failed btrbk of /o. restoring old host as primary
-  m $old_shell /a/exe/primary-setup localhost
+  if ! m $old_shell /a/exe/primary-setup localhost; then
+    die "due to failed btrbk of /o, we tried to restore old host as primary, but then we failed at that too. To resolve: Fix & rerun switch-mail-host, or fix and rerun primary-setup localhost on old shell so you have a working mail server and then rerun switch-mail-host."
+  fi
+  e finished restoring old host as primary, now exiting $ret due to earlier failed btrbk of /o.
   exit $ret
 fi
 
 # new system is usable at this point
-printf "$(tput setaf 5 2>/dev/null ||:)█$(tput sgr0 2>/dev/null||:)%.0s" $(eval echo "{1..${COLUMNS:-60}}")
-echo
+blocks=██████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████
+printf "%s\n" "${blocks:0:${COLUMNS:-100}}"
 
 # once I accidentally accepted incoming mail on old host. I used this script to copy over that mail:
 #